<?php
/* Remo File Report - concrete5 file download statistics
 * Copyright (C) 2011 Remo Laubacher
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

defined('C5_EXECUTE') or die("Access Denied.");

class RemoFileReportModel {
   public static function getActionInstance($action) {
      switch ($action) {
         case 'day':
            return new RemoFileReportDay();
            break;
         case 'week':
            return new RemoFileReportWeek();
            break;
         default:
            throw new Exception(t('Unsupported action in model remo_file_report.php.'));
      }
   }
}

interface IRemoFileReport {
   public function getData();
}

class RemoFileReportDay implements IRemoFileReport {
   public function getData() {
      $db = Loader::db();
      $ret['renderer'] = 'table';
      $ret['tableData'] = $db->GetAll('SELECT fv.fvFilename Filename,count(*) Download_Count
         FROM DownloadStatistics ds INNER JOIN FileVersions fv ON ds.fID=fv.fID AND ds.fvID=fv.fvID
         WHERE date(timestamp) = CURRENT_DATE
         GROUP BY fv.fID, fv.fvID, fv.fvFilename
         ORDER BY count(*) DESC');

      return $ret;
   }
}

class RemoFileReportWeek implements IRemoFileReport {
   public function getData() {
      $db = Loader::db();
      $ret['renderer'] = 'table';
      $ret['tableData'] = $db->GetAll('SELECT fv.fvFilename Filename,count(*) Download_Count
         FROM DownloadStatistics ds INNER JOIN FileVersions fv ON ds.fID=fv.fID AND ds.fvID=fv.fvID
         WHERE YEARWEEK(timestamp) = YEARWEEK(CURRENT_DATE) 
         GROUP BY fv.fID, fv.fvID, fv.fvFilename
         ORDER BY count(*) DESC');

      return $ret;
   }
}
?>